unit Trame;
//----------------------------------------------------------------------------//
//             TRAMAGE.PAS  Digo DELPY                                      //
//             http://assemple.free.fr                                        //
//             assemple@free.fr                                               //
//----------------------------------------------------------------------------//

//----------------------------------------------------------------------------//
// La fonction Canvas.StrechDraw qui appelle Windows.StretchBlt               //
// fonctionne trs mal sur les imprimantes monochrome                         //
// L'image obtenue sur l'imprimante est l'agrandissement de l'image trame    //
// J'ai essay d'agrandir l'image AVANT de la faire tramer par                //
// Canvas.StrechDraw mais a provoquait trop de plantages. Il est vrai que les//
// images agrandie avant tramage faisaient plus dizaine de Mo.                //
// Je me suis rsolu  "tramer" moi-mme l'image. J'ai utilis plusieurs      //
// techniques, et en ai conserves 3.                                         //
// TypeDeTramage=1 par dfaut donn le meilleur rsultat. C'est une trame de  //
// 16 pixels physiques avec un masque en croix voir "Trame de 16 pixels (4x4)"//
// Les deux autres type de tramage sont  tester                              //
// TypeDeTramage=2 est tramage allatoire qui donne une sensation de flou     //
// rugueux tandis que TypeDeTramage=3 est un tramage carr                    //
// Les 2 premiers types de tramage donnent un rendu un peu fonc              //
// Je vous conseille de tenter de les eclaircir (Pour le type 2 il est dj   //
// partiellement clairci par Random(210) au lieu de Random(254)              //
//----------------------------------------------------------------------------//

//----------------------------------------------------------------------------//
// Comment Utiliser PrinterStrechDraw (How to use PrinterStrechDraw)          //
// Remplacez : (Replace)                                                      //
//   Printer.Canvas.StrechDraw(Rect,MyJpeg) ou (OR) Printer.Canvas.StrechDraw(Rect,MyBitMap)
// PAR (BY)                                                                   //
//   PrinterStrechDraw(Rect,MyJpeg) ou (OR) PrinterStrechDraw(Rect,Nil,1,MyBitMap)
//                                                                            //
// Pour utiliser les autre Types de Tramage (to uses others type of rastering)//
//   PrinterStrechDraw(Rect,MyJpeg,2) ou (OR) PrinterStrechDraw(Rect,Nil,2,MyBitMap)
// Et (AND)                                                                   //
//   PrinterStrechDraw(Rect,MyJpeg,3) ou (OR) PrinterStrechDraw(Rect,Nil,3,MyBitMap)
// Bien sr, Ajoutez dans une clause USES l'unit TRAME                       //
// (Of course, add TRAME in USES)                                             //



//-----------------------------------------------------------------------------//
// A FAIRE : (TO DO)                                                           //
// Eclaircir les images que je trouve un peu sombre, sans faire disparatre    //
// les nuances dans les CLAIRS.                                                //
// Plusieurs pistes en modifiant la COULEUR puise dans BitMap.Canvas.Pixels[..]
// - COULEUR := COULEUR + Delta (5..15 ?)  // Leger Eclaircissement            //
// - COULEUR = Fonction(COULEUR) comme                                         //
//   par exemple :                                                             //
//   Couleur := Round(Couleur + cos( Couleur / 256 * 2 * pi )* ABS(Couleur-128) / 10   ) ;
//   Modification de la courbe de rendu de luminosit                          //
//  - ...                                                                      //
// Agrandir la trame, 16 x 16 permettrait par exemple de ne pas avoir  grer  //
// l'erreur d'arondi puisque cette trame permet de reprsenter 256 niveaux de gris
//-----------------------------------------------------------------------------//




interface
uses Windows, types, Printers, Graphics, Jpeg ;
Procedure  PrinterStrechDraw(             R : TRect ;
                                      Image : TJPegImage ;
                              TypeDeTramage : integer = 1 ;  // 1, 2 ou 3
                                     Bitmap : TBitMap = Nil
                             ) ;

implementation
Procedure  PrinterStrechDraw(R : TRect ; Image : TJPegImage ; TypeDeTramage : integer = 1 ; Bitmap : TBitMap = Nil  ) ;
Var
       BPP: Integer;
       ExMM : Integer ;
       I, X,Y, X2, Y2 : Integer ;
       Lpix,Hpix : Real ;
       Ok : Boolean ;
       Couleur : TColor ;
       Hp, Lp : Real  ;
       T : TextFile ;
       EX_MM : Integer ;
       //Couleurs : Array[-1..1,-1..1] of Byte ; supprim - tait envisag pour correction d'erreur (arrondi) radiale
       xx, yy : array[1..16] of Byte ;
       Erreur : Byte ;
       ErreurH : array of Byte ;
begin
  BPP := GetDeviceCaps(Printer.Canvas.Handle, BITSPIXEL) * GetDeviceCaps(Printer.Canvas.Handle, PLANES);
  If  (BPP<8) // donc Imprimante en N&B (Black and White Printer)
    and                           //   E T  //
      (R.Right-R.Left>Image.Width)// L'image doit tre agrandie (Picture must be enlarged) SINON StrechDraw CONVIENT
                                  //                                             (ELSE StrechDraw )
  then
  Begin

    EX_MM := SetMapMode(Printer.Canvas.Handle,mm_text) ;
    If EX_MM=mm_HiMetric then
    // Si le systme de coordonnes en cours est mm_HiMetric (dizimes de mm)
    // A FAIRE : grer les autres MapMode (TO DO : manage others MapMode)
    Begin
      R.Right := Round(R.Right / 2540 * Printer.Canvas.Font.PixelsPerInch) ;
      R.Left := Round(R.Left / 2540 * Printer.Canvas.Font.PixelsPerInch) ;
      R.Top := Round(-R.Top / 2540 * Printer.Canvas.Font.PixelsPerInch) ;
      R.Bottom := Round(-R.Bottom / 2540 * Printer.Canvas.Font.PixelsPerInch) ;
    End ;
    // Nombre de Pixel PHYSIQUES du rectangle de destination
    Lpix := (R.Right-R.Left) ;
    Hpix := (R.Bottom-R.Top) ;
    If BitMap=Nil then
    // Creation d'un BitMap quivalent au JPEG
    Begin
      If Image {TJpeg !} = NIL then EXIT ; // Jpeg=Nil possible IF BitMap<>Nil !!!!
      BitMap := TBitMap.Create ;
      BitMap.PixelFormat := pf24bit ;
      BitMap.Width := Image.Width ;
      BitMap.Height  := Image.Height ;
      BitMap.Canvas.Draw(0,0,Image) ;
    End ;
    // Dimension d'un Pixel de l'image en pixel du Printer.Canvas
    Lp := LPix / BitMap.Width ;
    Hp := HPix / BitMap.Height ;
    Printer.Canvas.Brush.Style := bsSolid ;
    Printer.Canvas.Brush.Color := ClBlack ;
    Printer.Canvas.Pen.Color := ClBlack ;
    If TypeDeTramage<2 then
    // TypeDeTramage = 1 : Trame de 16 pixels (4x4)
    Begin
       xx[1] := 1 ; yy[1] := 1 ;     //                                                     //
       xx[2] := 2 ; yy[2] := 2 ;     //           0   1   2   3                             //
       xx[3] := 2 ; yy[3] := 1 ;     //         |---|---|---|---|                           //
       xx[4] := 1 ; yy[4] := 2 ;     //      0  | 5 | 9 | G | 7 |     A = 10                //
       xx[5] := 0 ; yy[5] := 0 ;     //         |---|---|---|---|           ...  G = 16     //
       xx[6] := 3 ; yy[6] := 3 ;     //      1  | D | 1 | 3 | C |                           //
       xx[7] := 3 ; yy[7] := 0 ;     //         |---|---|---|---|                           //
       xx[8] := 0 ; yy[8] := 3 ;     //      2  | B | 4 | 2 | E |                           //
       xx[9] := 1 ; yy[9] := 0 ;     //         |---|---|---|---|                           //
       xx[10] :=2  ; yy[10] := 3 ;   //      3  | 8 | F | A | 6 |                           //
       xx[11] :=0  ; yy[11] := 2 ;   //         |---|---|---|---|                           //
       xx[12] :=3  ; yy[12] := 1 ;   //                                                     //
       xx[13] :=0  ; yy[13] := 1 ;   //                                                     //
       xx[14] :=3  ; yy[14] := 2 ;   //  Ce masque de trame peut tre amlior.
       xx[15] :=1  ; yy[15] := 3 ;   //  Par exemple recentr
       xx[16] :=2  ; yy[16] := 0 ;   //  (This Raster can be enhanced, for exemple recentered)
       Erreur := 0 ;
       SetLength(ErreurH,(R.Bottom  - R.Top) div 4 + 1) ;
       X2 := R.Left ;
       Repeat
         Y2 := R.Top ;
         Repeat
           X := Round((X2-R.Left)/Lp) ;
           Y := Round((Y2-R.Top)/Hp) ;
           Couleur := Bitmap.Canvas.Pixels[X,Y] ;
           Couleur := (Couleur and $FF + (Couleur and $FF00 )div 255 +  ((Couleur and $FF0000 ) div 255) div 255) DIV 3 ;
           // Correction de l'erreur d'arrondi reporte (Dithering)
           Couleur := Couleur + erreur ;
           If X2 > R.Left then Couleur := Couleur + erreurH[(Y2-R.Top) div 4] ;
           // Report de la Correction de l'erreur d'arrondi (Dithering)
           Erreur := Couleur Mod 16 ;
           // Repartition de l'erreur sur les point Y+1, et X+1, et (X+1,Y-1)
           erreurH[(Y2-R.Top) div 4] := erreur div 5 * 2 ;
           erreurH[(Y2-R.Top-4) div 4] := erreurH[(Y2-R.Top-4) div 4] + erreur div 5  ;
           erreur := erreur - (erreur div 5 * 3) ;
           // Arrondissement de la Couleur, celle-l mme qui produit l'erreur : couleur mod 16
           Couleur := Couleur div 16 ;
           // Traage du masque de trame
           For I := 1 to 16 do
           Begin
             If Couleur>15 then Break ;
             Printer.Canvas.Pixels[X2+xx[i],Y2+yy[i]] := clBlack ;
             Inc(Couleur) ;
           End ;
           Y2 := Y2 + 4 ; // Trame suivante
         Until Y2>=R.Bottom ;
         X2 := X2 + 4 ; // Trame suivante
       Until X2>=R.Right ;
    End Else
    // Type de tramage 2 et 3 : Trames en partant de la source
    // la trame dpend du rapport taille Image / Taille en pixel de la destination
    For X := 0 to BitMap.Width do
    For Y := 0 to BitMap.Height do
    Begin
       Couleur := Bitmap.Canvas.Pixels[X,Y] ;
       Couleur := (Couleur and $FF + (Couleur and $FF00 )div 255 +  ((Couleur and $FF0000 ) div 255) div 255) DIV 3  ;
       //Couleur := Round(Couleur + cos( Couleur / 256 * 2 * pi )* ABS(Couleur-128) / 10   ) ;
           // ligne supprime - correction de courbe luminosite
       If TypeDeTramage=2 then
       // TypeDeTramage=3 : Trame alatoire (Random Rastering)
       Begin
         For X2 := Round( (X-0.5) * Lp) to Round( (X+0.5) * Lp) do
         For Y2 := Round( (Y-0.5) * Hp) to Round( (Y+0.5) * Hp) do
         If Random(210)>Couleur then Printer.Canvas.Pixels[R.Left+X2,R.Top+Y2] := clBlack ;
       End Else
       // un carr d'une taille inversement proportionnelle  la clart du point  reproduire est trac
       // (translate yourself !!!)
       If Couleur<255 then
       Printer.Canvas.Rectangle(R.Left+Round(X*Lp-(Lp*(255-couleur)/255/2)),
                      R.Top+Round(Y*Hp-(Hp*(255-couleur)/255/2)),
                      R.Left+Round(X*Lp+(Lp*(255-couleur)/255/2+0.5)),
                      R.Top+Round(Y*Hp+(Hp*(255-couleur)/255/2+0.5))
                      );
    End ;
    Printer.Canvas.Brush.Color := ClWhite ;
    Printer.Canvas.Pen.Color := ClBlack ;
    Printer.Canvas.Brush.Style := bsClear ;
    BitMap.Free ;
    SetMapMode(Printer.Canvas.Handle,EX_mm) ;
  End Else
  If BitMap=Nil then
  Begin
    If Image<>Nil then
    Begin
      Printer.Canvas.StretchDraw(R,Image);  // Si je ne double pas STRECHDRAW, l'image n'est pas toujours imprime
      Printer.Canvas.StretchDraw(R,Image);  // Pourquoi ? Je ne sais pas !
    End ;
  End else
  Begin
    Printer.Canvas.StretchDraw(R,BitMap);  // Si je ne double pas STRECHDRAW, l'image n'est pas toujours imprime
    Printer.Canvas.StretchDraw(R,BitMap);  // Je ne sais pas si ce problme se produit AUSSI avec un TBitMap ?
  End ;
end;

end.
